100 REMark Santa and the Maze, by Dilwyn Jones, 24th December 2010
110 REMark change sound_on% to 0 to play without sound
120 sound_on% = 1
130 :
140 REMark to use larger display, just increase size of window and then
150 REMark adjust variables 'down' and 'across' below
160 WINDOW 512,202,0,0     : BORDER 1,255    : PAPER 7    : INK 0
170 WINDOW #0,512,52,0,202 : BORDER #0,1,255 : PAPER #0,0 : INK #0,4
180 RANDOMISE
190 Initialise
200 :
210 REPeat program
220   REMark start new game
230   CLS : CLS #0 : CSIZE 1,0
240   :
250   down = 16 :across = 34 : REMark maze size
260   :
270   MAKE_A_MAZE : REMark design maze...
280   MAP_MAZE    : REMark ...show maze, reindeer and presents
290   PRINT #0,"Some unkind person is out to sabotage Christmas. Santa's reindeer are all lost in"
300   PRINT #0,"the maze. So are a number of children's presents. Santa needs help to recover them."
310   PRINT #0,'Guide Santa around the maze with ';CHR$(188);CHR$(189);CHR$(190);CHR$(191);' or ESC to quit... Good luck!'
320   :
330   REMark main program loop - guide Santa around using cursor arrow keys
340   :
350   x = inx : y = iny : REMark Santa position
360   :
370   reindeer = 0 : REMark number of reindeer recovered
380   presents = 0 : REMark number of presents recovered
390   bumps    = 0 : REMark how many times have you bumped Santa into a wall
400   :
410   start_time = DATE
420   :
430   frame = 0
440   REPeat game
450     CURSOR 14*x+4,11*y+1 : INK 2 : PRINT CHR$(santa+frame); : INK 0
460     IF font2base > 0 THEN frame = NOT frame : REMark no animation without new font
470     CURSEN #0
480     REPeat get_key
490       seconds = DATE-start_time+1
500       AT 0,2 : PRINT INT(seconds/60)&'m '&(seconds-60*INT(seconds/60))&'s  ';
510       key = CODE(INKEY$(#0,50))
520       IF key <> 0 THEN CURDIS #0 : EXIT get_key
530     END REPeat get_key
540     BLOCK 8,10,14*x+4,11*y+1,7 : REMark delete Santa's previous position
550     SELect ON key
560       =27 : EXIT game : REMark Esc
570       =192 : REMark left (west)
580         IF x = 1 AND y = iny THEN
590           IF sound_on% : BEEP RND(1000 TO 5000),50
600           PRINT #0,"Can't go out that way!" : NEXT game
610         END IF
620         IF x = 1 OR ((maze(y,x)&&8) = 0) THEN Ouch : NEXT game : REMark can't go that way
630         x = x - 1 : REMark move left
640       =200 : REMark right (east)
650         IF x = across AND y = outy THEN
660           REMark at the exit, but can only exit if all reindeer and presents recovered
670           IF reindeer < 8 OR presents < 8 THEN
680             PRINT #0,"Can't exit, not all reindeer and presents recovered!" : NEXT game
690           END IF
700         END IF
710         IF ((maze(y,x) && 2) = 0) THEN Ouch : NEXT game : REMark that way blocked
720         x = x + 1
730       =208 : REMark up (north)
740         IF y = 1 OR ((maze(y,x)&&1) = 0) THEN Ouch : NEXT game : REMark can't go further that way
750         y = y - 1
760       =216 : REMark down (south)
770         IF y = down OR ((maze(y,x) && 4) = 0) THEN Ouch : NEXT game : REMark can't go that way
780         y = y + 1
790     END SELect
800     :
810     REMark if by the exit, and all Santa's reindeer and presents collected, end the game
820     IF x = outx+1 AND y = outy THEN
830       IF reindeer+presents = 16 THEN
840         PRINT #0,'Santa has managed to collect all the reindeer and presents, and escaped from the maze, well done!'
850         EXIT game
860       END IF
870     END IF
880     :
890     IF object(y,x) > 0 THEN
900       REMark we have recovered a reindeer or present
910       IF sound_on% : BEEP RND(100 TO 1000),RND(0 TO 10)
920       PRINT #0,'Recovered ';object$(object(y,x))
930       IF object(y,x) < 9 THEN
940         reindeer = reindeer + 1
950         CURSOR 100+10*reindeer,0 : INK 2 : PRINT CHR$(rdeer);
960       ELSE
970         presents = presents + 1
980         CURSOR 190+10*presents,0 : INK 4 : PRINT CHR$(gifts);
990       END IF
1000       INK 0
1010       PRINT #0,'Santa has recovered ';reindeer;' reindeer and ';presents;' present';
1020       IF presents = 1 THEN PRINT #0, : ELSE PRINT #0,'s' :END IF
1030       object(y,x) = 0
1040       IF reindeer+presents = 16 THEN PRINT #0,'Now all Santa has to do is find his way out of the maze.'
1050     END IF
1060     :
1070     REMark is there a gift or reindeer nearby?
1080     FOR a = -1 TO 1
1090       FOR b = -1 TO 1
1100         obj = object(y+a,x+b)
1110         SELect ON obj
1120           =1 TO 8 : PRINT #0,object$(obj);' is nearby.'
1130           =9 TO 16: PRINT #0,'Santa is near a present.'
1140         END SELect
1150       END FOR b
1160     END FOR a
1170     :
1180   END REPeat game
1190   :
1200   PRINT #0,'Game finished in ';DATE-start_time+1;' seconds.'
1210   PRINT #0,'Another game Y/N ? ';
1220   IF YN$ == 'n' THEN EXIT program
1230 END REPeat program
1240 :
1250 PRINT #0,'Program finished.'
1260 REMark release font area and restore original font
1270 IF font2base > 0 THEN RECHP(font2base) : font2base = 0 : CHAR_USE #1,0,0
1280 :
1290 STOP
1300 :
1310 DEFine PROCedure MAKE_A_MAZE
1320   DIM maze(down+1,across+1)
1330   DIM object(down+1,across+1)
1340   inx = 1 : iny = RND(1 TO down)
1350   x = inx : y = iny
1360   maze(y,x) = maze(y,x) || 32
1370   outy = RND(1 TO down) : outx = across
1380   FOR ac = 1 TO across : maze(0,ac) = 32 : maze(down+1,ac) = 32
1390   FOR dn = 1 TO down : maze(dn,0) = 32 : maze(dn,across+1) = 32
1400   maze(iny,inx) = maze(iny,inx) || 8
1410   maze(outy,outx) = maze(outy,outx) || 2
1420   REPeat outer
1430     IF (maze(y,x+1) && 48) <> 0 AND (maze(y,x-1) && 48) <> 0 AND (maze(y+1,x) && 48) <> 0 AND (maze(y-1,x) && 48) <> 0 THEN
1440       maze(y,x) = (maze(y,x) && 239) || 32
1450       IF (maze(y-1,x)&&20) = 20 THEN y = y - 1 : NEXT outer
1460       IF (maze(y,x+1)&&24) = 24 THEN x = x + 1 : NEXT outer
1470       IF (maze(y+1,x)&&17) = 17 THEN y = y + 1 : NEXT outer
1480       IF (maze(y,x-1)&&18) = 18 THEN x = x - 1 : NEXT outer
1490       EXIT outer
1500     END IF
1510     REPeat inner
1520       rand_no = RND(0 TO 9)
1530       newx = x + (rand_no=0 OR rand_no=1) - (rand_no=5 OR rand_no=6)
1540       newy = y + (rand_no=2 OR rand_no=3 OR rand_no=4)-(rand_no=7 OR rand_no=8 OR rand_no=9)
1550       IF (maze(newy,newx)&&48) = 0 THEN EXIT inner
1560     END REPeat inner
1570     maze(newy,newx) = maze(newy,newx) || 16
1580     SELect ON rand_no
1590       =7,8,9 : maze(y,x) = maze(y,x) || 1 : maze(newy,newx) = maze(newy,newx) || 4
1600       =0,1   : maze(y,x) = maze(y,x) || 2 : maze(newy,newx) = maze(newy,newx) || 8
1610       =2,3,4 : maze(y,x) = maze(y,x) || 4 : maze(newy,newx) = maze(newy,newx) || 1
1620       =5,6   : maze(y,x) = maze(y,x) || 8 : maze(newy,newx) = maze(newy,newx) || 2
1630     END SELect
1640     x = newx : y = newy
1650   END REPeat outer
1660   maze(outy,outx) = (maze(outy,outx) && 239) || 32
1670 END DEFine MAKE_A_MAZE
1680 :
1690 DEFine PROCedure MAP_MAZE
1700   FOR dn = 1 TO down+1   : BLOCK 14*across+2,1,14,11*dn,0
1710   FOR ac = 1 TO across+1 : BLOCK 2,11*down+1,ac*14,11,0
1720   FOR dn = 1 TO down
1730     FOR ac = 1 TO across
1740       IF (maze(dn,ac)&&2) = 2 THEN BLOCK 2,10,14*(ac+1),11*dn+1,7
1750       IF (maze(dn,ac)&&4) = 4 THEN BLOCK 12,1,14*ac+2,11*(dn+1),7
1760     END FOR ac
1770   END FOR dn
1780   BLOCK 2,10,14,11*iny+1,7
1790   BLOCK 2,10,14*(across+1),11*outy+1,7
1800   CURSOR 2,11*iny+1 : PRINT CHR$(185); : REMark >>
1810   CURSOR 14*(across+1)+2,11*outy+1 : PRINT CHR$(185); : REMark >>
1820   :
1830   REMark insert reindeer and presents at random positions
1840   FOR a = 1 TO 16
1850     REPeat outer
1860       y = RND(1 TO down) : x = RND(1 TO across)
1870       REMark can't be at Santa's start position
1880       IF y = iny AND x = inx THEN NEXT outer
1890       IF object(y,x) = 0 THEN
1900         CURSOR 14*x+4,11*y+1
1910         IF a < 9 THEN
1920           INK 2 : REMark reindeer colour
1930           IF fontbase = 0 THEN PRINT CHR$(rdeer); : ELSE PRINT CHR$(rdeer-1+RND(1 TO 2)); : END IF
1940         ELSE
1950           INK 4: REMark gift colour
1960           IF fontbase = 0 THEN PRINT CHR$(gifts); : ELSE PRINT CHR$(gifts-1+RND(1 TO 2)); : END IF
1970         END IF
1980         object(y,x) = a : REMark reindeers first 8, then gifts
1990         EXIT outer
2000       END IF
2010       REMark try again to find a vacant square
2020     END REPeat outer
2030   END FOR a
2040   INK 0
2050 END DEFine MAP_MAZE
2060 :
2070 REMark $$off
2080 DEFine PROCedure Sa
2090   SAVE win1_xmas_santa_bas
2100   QSAVE win1_xmas_santa : REMark remove if you don't have QSAVE
2110 END DEFine Sa
2120 :
2130 DEFine PROCedure xtv
2140   OUTLN #0,FLIM_W(#0),FLIM_H(#0),0,0
2150   WINDOW FLIM_W(#0),FLIM_H(#0)-52,0,0 : WINDOW #2,FLIM_W(#0),FLIM_H(#0)-52,0,0 : WINDOW #0,FLIM_W(#0),52,0,FLIM_H(#0)-52
2160   BORDER #1,1,255 : BORDER #2,1,255 : BORDER #0,1,255
2170   CLS : CLS #2 : CLS #0
2180 END DEFine xtv
2190 REMark $$on
2200 :
2210 DEFine PROCedure Initialise
2220   LOCal a
2230   REMark set up names of reindeer and gifts
2240   REMark names may be up to 16 characters long
2250   DIM object$(16,16) : REMark 8 reindeer, 8 gifts
2260   DATA 'Dasher','Dancer','Prancer','Vixen'
2270   DATA 'Comet','Cupid','Donner','Blitzen'
2280   DATA 'Gift 1'
2290   DATA 'Gift 2'
2300   DATA 'Gift 3'
2310   DATA 'Gift 4'
2320   DATA 'Gift 5'
2330   DATA 'Gift 6'
2340   DATA 'Gift 7'
2350   DATA 'Gift 8'
2360   RESTORE
2370   FOR a = 1 TO 16 : READ object$(a)
2380   :
2390   REMark try to set new font 2
2400   READ nbytes
2410   font2base = ALCHP(nbytes)
2420   IF font2base <= 0 THEN
2430     font2base = 0
2440     PRINT #0,'Unable to install new font.'
2450     REMark codes of UDGs when new font not used
2460     rdeer = CODE('R') : santa = CODE('S') : gifts = CODE('G')
2470   ELSE
2480     FOR a = font2base TO font2base+nbytes-1
2490       READ byte : POKE a,byte
2500     END FOR a
2510     CHAR_USE #1,0,font2base
2520     REMark codes of UDGs
2530     rdeer = 128 : santa = 130 : gifts = 132
2540   END IF
2550 END DEFine Initialise
2560 :
2570 DEFine PROCedure Ouch
2580   LOCal rndm
2590   REMark this gets called when Santa bumps into a wall
2600   IF sound_on% : BEEP RND(1000 TO 5000),50
2610   rndm = RND(1 TO 5)
2620   SELect ON rndm
2630     =1 : PRINT #0,'* Ouch *'
2640     =2 : PRINT #0,'Doh, Santa walked into a wall!'
2650     =3 : PRINT #0,"Can't go that way!"
2660     =4 : PRINT #0,'Why are you trying to go through a wall?'
2670     =5 : PRINT #0,'Ouch, that hurt'
2680   END SELect
2690   bumps = bumps + 1
2700   PRINT #0,'Santa has now had ';bumps;' bump';
2710   IF bumps = 1 THEN PRINT #0, : ELSE PRINT #0,'s'
2720   SELect ON bumps
2730     =10 : PRINT #0,'Santa is getting a headache.'
2740     =20 : PRINT #0,'Why do you insist on hurting Santa so much?'
2750     =30 : PRINT #0,"Santa won't visit you this year for bumping him into so many walls!"
2760     =40 : PRINT #0,'Stop bumping me into walls!'
2770     =50 : PRINT #0,"Watch were you're going, will you?"
2780   END SELect
2790 END DEFine Ouch
2800 :
2810 DEFine FuNction YN$
2820   LOCal loop,k$
2830   CURSEN #0
2840   REPeat loop
2850     k$ = INKEY$(-1)
2860     IF k$ == 'y' OR k$ == 'n' THEN EXIT loop
2870   END REPeat loop
2880   PRINT #0,k$
2890   RETurn k$
2900 END DEFine YN$
2910 :
2920 DATA 551,127,60
2930 DATA 170,85,170,85,170,85,170,85,170,4,20,10,135,127,127,252,172,170,133,82,36,255,90,126,60,60,24
2940 DATA 56,24,62,125,152,60,36,38,96,56,24,124,190,25,60,36,100,6,0,254,255,201,201,255,201,201,127
2950 DATA 0,127,255,147,147,255,147,147,254,0,0,60,76,84,100,120,0,0,68,0,0,68,68,68,60,0,0
2960 DATA 0,0,60,64,64,64,60,16,32,20,40,0,120,68,68,68,0,0,0,0,120,20,56,80,60,0,0
2970 DATA 0,0,40,84,88,80,44,0,0,8,16,52,76,68,76,52,0,0,32,16,52,76,68,76,52,0,0
2980 DATA 16,40,0,60,68,76,52,0,0,68,0,56,68,124,64,60,0,0,32,16,56,68,124,64,60,0,0
2990 DATA 16,40,56,68,124,64,60,0,0,68,0,0,16,16,16,8,0,0,8,16,0,16,16,16,8,0,0
3000 DATA 32,16,0,16,16,16,8,0,0,16,40,0,16,16,16,8,0,0,8,16,56,68,68,68,56,0,0
3010 DATA 32,16,56,68,68,68,56,0,0,16,40,0,56,68,68,56,0,0,8,16,68,68,68,68,60,0,0
3020 DATA 32,16,68,68,68,68,60,0,0,16,40,0,68,68,68,60,0,0,56,68,68,88,68,68,88,64,64
3030 DATA 0,16,60,80,80,80,60,16,0,68,68,40,16,124,16,56,0,0,32,16,0,0,0,0,0,0,0
3040 DATA 68,16,40,68,124,68,68,0,0,20,40,16,40,68,124,68,0,0,16,40,16,40,68,124,68,0,0
3050 DATA 8,16,124,64,124,64,124,0,0,68,56,68,68,68,68,56,0,0,20,40,56,68,68,68,56,0,0
3060 DATA 52,68,76,84,100,68,88,0,0,68,0,68,68,68,68,56,0,0,56,68,64,64,64,68,56,16,32
3070 DATA 56,0,68,100,84,76,68,0,0,60,72,72,124,72,72,76,0,0,60,72,72,76,72,72,60,0,0
3080 DATA 0,0,36,88,72,88,36,0,0,56,68,64,56,68,68,56,0,0,56,68,68,124,68,68,56,0,0
3090 DATA 96,16,16,16,40,72,68,0,0,0,0,68,68,68,100,92,64,64,0,0,60,104,40,40,40,0,0
3100 DATA 16,16,56,84,84,84,56,16,16,16,0,16,16,16,16,16,0,0,16,0,16,32,64,68,56,0,0
3110 DATA 24,36,112,32,112,36,24,0,0,56,68,64,56,68,56,4,68,56,0,68,56,68,68,56,68,0,0
3120 DATA 0,20,40,80,40,20,0,0,0,0,80,40,20,40,80,0,0,0,16,40,16,0,0,0,0,0,0
3130 DATA 0,16,0,124,0,16,0,0,0
